<html>
<head>

<!-- 
 University of Illinois/NCSA Open Source License for groupcreate.php.

 Copyright (c) 2009 Jim Champ/Surrey County Council
 All rights reserved.
 Developed by: 		Jim Champ
 www.devboats.co.uk/groupcreate
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal with the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimers.

 Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and the following disclaimers
 in the documentation and/or other materials provided with the
 distribution.

 Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
 or promote products derived from this Software without specific prior
 written permission.
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
 
-->

<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>Active Directory Group Creation Utility</title>

</head>
<body>

<h1>DS Batch Group Creation Utility</h1>

<div>
<?php 

// This is an AD version
// AD is significantly different to most Edirectory installations
// CN=Administrator,CN=Users,DC=domain,DC=yourcompany,DC=co,DC=uk<p>

if (@$_POST['ldap_id'] > "" ) {
	// newer systems support the _post system for posted variable
	// older ones http_post_vars so we test for both...
	$working_ou=$_POST['working_ou'];
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_id=$_POST['ldap_id'];
	$ldap_server=$_POST['ldap_server'];
	$csv_data_file=$_POST['csv_data_file'];	
} else {
	if (@$HTTP_POST_VARS['ldap_id'] > "" ) { 
		$working_ou=$HTTP_POST_VARS['working_ou'];
		$ldap_pw=$HTTP_POST_VARS['ldap_pw'];
		$ldap_id=$HTTP_POST_VARS['ldap_id'];
		$ldap_server=$HTTP_POST_VARS['ldap_server'];
		// and this will come from our data file in the loop
		$csv_data_file=$HTTP_POST_VARS['csv_data_file'];	
	} else {
		// if we haven't got any ldap id set go to the authentication form
		printintro();
		closedocument();
		exit;
	}
}

echo "<p>Connection to LDAP server";

// basic sequence with LDAP is connect, bind, search, interpret search
// result, close connection
// So we start by connecting to LDAP
$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!
//these options seem to have to be set for AD to respond correctly to the LDAP calls
ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3);
ldap_set_option($ds, LDAP_OPT_REFERRALS, 0);

if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo " succeeded</p>\n<p>";
	// we have now made an LDAP connection
} else { 
	echo " failed.</p><h2>LDAP Authentication Failed</h2>\n";
	echo "<p>User id and/or Password credentials were incorrect</p>\n";
	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
	echo "correct LDAP syntax (cn=username,ou=unit,o=org) rather than NDS syntax for the user id.</p>\n";
	exit;
}

readinfile ($csv_data_file);
//this puts the csv in the array $arrbrecords
// we need to page through it
foreach ($arrbrecords as $c) {
	// in the csv field 0 is cn, field 1 is sAMAccountName (~= short name), field 2 is context, 3 is description, 4 on are group members...
	$viable_group = TRUE;
    //validate required fields...
    // if there is no cn, sam accountname or context then the 
    //creation or addition must not proceed...
	// so the trifgger var is set to false if any don't comply	
	if (strlen($c[0]) < 1 ) {
		$viable_group = FALSE;
	}
    if (strlen($c[1]) < 1 ) {
		$viable_group = FALSE;
	}
	if (strlen($c[2]) < 1 ) {
		$viable_group = FALSE;
	}
	
	if ($viable_group) {
		$group_naming_attrs['cn'] = $c[0];
	    $group_naming_attrs['sAMAccountName'] = $c[1];
		$group_ou =  $c[2] . "," . $working_ou;
		// and create the full DN
		$group_dn = "cn=" . $group_naming_attrs['cn'] . "," . $group_ou ;

		if (strlen($c[3]) >0 ) {
			// if the description is absent we don't set the attr because
			// the LDAP add command will fail if there are any null attribute values 
			$group_naming_attrs['description'] = $c[3];
		}
		
	    //object class group for groups in AD. top is probably a work of supererogation, but
	    // better safe than sorry, besides in its various example code I plundered on the
	    // php documentation pages
	    $group_naming_attrs['objectClass'][0] = "top";
		$group_naming_attrs['objectClass'][1] = "group";
	    
		// first we find if the group exists: if it does that's fine...
		// so search for it in its DN, using its CN
		// if the system has got multiple groups with the same CN under the context
		// then it will return all of them which is a potential glitch, but serve 'em right!
	    //echo "<br>Group OU $group_ou <br>Group DN $group_dn  <br>third bit" . "(sAMAccountName=" . ldap_escape($group_naming_attrs['sAMAccountName']).")<br>";
	    // we are widely using sAMAccountName rather than CN for lookups etc. This is the typically 
	    // shorter "pre windows 2000" name
	    // note that the ldap_escape is a very rudimentary function and you may well have issues 
	    // if your admins use characters other than a-z,1-9...
	    // this is a likely place for problems. You can find a lot about escaping functions, AD 
	    // and ldap_search in the php documentation on line. I had problems with all the examples
	    // but didn't have a need for the more advanced options so left it out. More in
	    // comments in the function itself!
	    
	    $sr = ldap_search($ds, $group_ou, "(sAMAccountName=" . ldap_escape($group_naming_attrs['sAMAccountName']).")");
	    $entry_count = ldap_count_entries($ds, $sr);
	    echo "<br> Group search found $entry_count groups<br>";
	    // this is a flag to see if we have one and only one group with the right sAMAccountName
	    $group_present = FALSE; 
	    // if the group doesn't exist 
	    if($entry_count < 1) {
	    	// we try and create it
			if (ldap_add($ds, $group_dn, $group_naming_attrs)) {
		  		echo "Creation of group $group_dn Succeeded.<br>\n";
		  		$group_present = TRUE;  
			}else{
				echo "Creation of group $group_dn failed.<br>\n";
	    	}
	    } elseif ($entry_count > 1) { 
	    	echo "Multiple Groups named " . $group_naming_attrs['sAMAccountName'] . " exist under context $group_ou.<br>\n";
	    } else {
	    	//echo  "Group $group_dn exists OK...<br>\n";
	      	$group_present = TRUE;  
	    }
		if ($group_present) {
		    //here we do all the group memberships...
			// either the group existed or we created it...
			// variable to store number of users processed...
			$user_count=0;
		    $arr_count=count($c);
		    for($r=4; $r < $arr_count; $r++) {
			    // having done that we need to do the group membership
			    // for each remaining item in $c
			    // in AD only the member attribute in the group needs populating, but
			    // you must populate group, doing it th other way doesn't work...
		    	$user_cn = $c[$r];
		    	// find matching object for user and get user dn
		    	if(strlen($user_cn)>0) {
		    		// flag for user present...
					$user_found=FALSE;
		    		$sr = ldap_search($ds, $working_ou, "(sAMAccountName=$user_cn)");
		    		// Count the number of entries returned and check for errors.
					//echo "<p>Search for $ds $working_ou sAMAccountName=$user_cn </p>\n";
					$entry_count = ldap_count_entries($ds, $sr);
					//echo "<p>Search completed, ".$entry_count . " entries found<br />\n";
					// we must have exactly one entry returned to be happy we are editing the right
					// object in the DS< else we must quit
					if($entry_count >1) {
						echo "$entry_count objects were found that match user $user_cn";
						echo " under OU $working_ou and were <b>skipped</b>.<br>\n";
						$entry_info=ldap_get_entries($ds, $sr);
						foreach ($entry_info as $entry_data) {
							if (strlen($entry_data["dn"])>0) {
								echo "&nbsp;&nbsp;&nbsp;&nbsp;" . $entry_data["dn"] . "<br>\n";
							}
						}
					} else {
						if($entry_count <1) {
							echo "No objects were found that match $user_cn under " . $working_ou ;
							echo ". This file entry was <b>skipped</b>.<br />\n";
						//continue;
						 } else {
							// we get the entries for this one result (!)
							$entry_info=ldap_get_entries($ds, $sr);
							$user_dn = $entry_info[0]["dn"];
							$user_found=TRUE;
						}
					}
					if ($user_found){
			    		//for group object
				 		$group_info['member'][] = $user_dn; // User's DN is added to group's 'member' array
				 		$user_count++;
						//if (ldap_mod_add($ds,$group_dn,$group_info)) {
					    //	echo "$user_count associations added to group $group_dn<br>\n";
						//}else{
					    //    echo "User association(s) failed on group $group_dn.<br>\n";
						//}
						//$group_info="";
				 		
					}
				    $user_info="";
		    	}
			}
			if (ldap_mod_add($ds,$group_dn,$group_info)) {
		    	echo "$user_count associations added to group $group_dn<br>\n";
			}else{
		        echo "User association(s) failed on group $group_dn.<br>\n";
			}
		}
	} else {
		//$viable_group is  false - we skipped it so message...
		echo "Invalid Group data $c[0] $c[1] $c[2] $c[3] : group skipped<br>\n";
	}
	$user_count = 0;
	$group_info="";
	$group_naming_attrs="";
	
}
echo "</p><h4>Important Note</h4>\n<p>Associations may fail because the association(s) already exist ";
echo "rather than because of an actual problem. This is more likely to happen when updating ";
echo "existing groups.</p>\n";
//closedocument();
exit;
    
function ReadinFile( $fname ) {
	//global arrey for output...
	global $arrbrecords;
	$arrholder = array();
	$arrptr = 0;
	//First we open the csv file
	$handle = @fopen($fname, "r");
	if ($handle== false) {
		echo "</p><h2>Data File Open Failed</h2>\n";
		echo "<p>There are a number of reasons why this might have happened. The file might genuinely not exists, or perhaps its stored \n";
		echo "on an area of the server where the script does not have rights to open files.</p>\n";
		echo "<p>Use back to go back to the form and correct the path opr move the file to somewhere the script ";
		echo "can definitely access it. The directory where the script is stored should always work.</p>\n";
		closedocument();
		exit;
	} 	

	$arrptr=0;
	while (!feof($handle)) {
		$arr_buffer = fgetcsv($handle, 4096);
		// we always test and that way handle blank records in teh file...
		// also we need to allow for their not being enough fields...
		$numrecs = count($arr_buffer);
		if ($numrecs > 4) {
			// then we have a potentially good line with four plus records and continue processing it in here
			// so we look at first two records and see if its got something in it...
			if (strlen(trim($arr_buffer[0])) < 2) { 
				continue;
			}
			if (strlen(trim($arr_buffer[1])) < 2) { 
				continue;
			}
			// OK we ve done crude validation and reckon we ve got some records
			// now we put data in the array
			for ($i = 0; $i < $numrecs; $i++) {
 			   //echo $i;
 			   $arrbrecords[$arrptr][$i] = trim($arr_buffer[$i]);
			}
		} else {
			// we got here because we didn t have 2 records in teh line of CSV
			// so we do nothing and continue
		}
		// and increment the array pointer
		$arrptr++;
	}
	// now close the file
	if (fclose($handle)) {
		//echo "\nFile Closed successfully<br />\n";
	} else {
		echo "\nFile Close Failed: contact Application Support.<br />\n";
	}
}    

function printintro() {
// this produces the form to fill in when there's not a ldap _id in the post vars. 
$a = <<<HTMLFORM
<center>
<FORM METHOD="POST" ACTION="adgrpcrt.php" ENCTYPE="x-www-form-urlencoded">
<TABLE class="main" CELLPADDING="2" CELLSPACING="2">
<TR>
    <TD class="maintdpos">LDAP Admin User ID: </TD> 
    <TD  class="maintdpos"><INPUT TYPE="text" value ="CN=Administrator,CN=Users,DC=domain,DC=yourcompany,DC=co,DC=uk" 
    NAME="ldap_id" SIZE="60" MAXLENGTH="90"></TD> 
</TR>
<TR>
    <TD  class="maintdpos">LDAP Password:</TD> 
    <TD  class="maintdpos"><INPUT TYPE="password" NAME="ldap_pw" SIZE="60" MAXLENGTH="40"></TD> 
</TR>
<TR>
    <TD  class="maintdpos">LDAP Server:</TD> 
    <TD  class="maintdpos"><INPUT TYPE="text" NAME="ldap_server" VALUE="addomaincontroller.domain.yourcompany.co.uk" 
    SIZE="60" MAXLENGTH="90"></TD> 
</TR>
<TR>
     <TD colspan="2">
	<HR>
     </TD>   	
</TR>
<TR>
    <TD  class="maintdpos">Base DC in AD:</TD> 
    <TD  class="maintdpos"><INPUT TYPE="text" NAME="working_ou" VALUE="DC=domain,DC=yourcompany,DC=co,DC=uk" 
    SIZE="60" MAXLENGTH="90"></TD> 
</TR>
<TR>
    <TD  class="maintdpos">CSV Data File:</TD> 
    <TD  class="maintdpos"><INPUT TYPE="text" NAME="csv_data_file" SIZE="60" MAXLENGTH="40"></TD> 
</TR>

<TR>
     <TD colspan="2">
	<HR>
     </TD>   	
</TR>

<TR> 
    <TD class="maintdpos"><INPUT TYPE="submit" VALUE="Post Details"></TD> 
   <TD class="maintdpos"><INPUT TYPE="reset" VALUE="Clear Form"></TD> 
</TR>
</TABLE>
</center>
<H3>Notes and Help</h3>
<p>LDAP Admin user id must be in typeful LDAP format ie <CODE>cn=adminuser,o=organisation</CODE>. The delimiters must be commas
and not full stops. In AD it could be something like CN=Administrator,CN=Users,DC=domain,DC=yourcompany,DC=co,DC=uk<p>
<p>LDAP server. This needs to be a domain controller for the domain.</p>
<p>Working OU/Context must also be in typeful; LDAP format, so <CODE>DC=domain,DC=yourcompany,DC=co,DC=uk</CODE> 
This controls how far down the tree the utility searches for group members. The higher up then the faster it runs, 
the lower down the more OUS can be processed. But you should not be creating group memberships that go outside 
the building container. </p>
<p>CSV data file can be a path local to the server where you are running the script, and this is preferred.
 It may be possible to use an HTTP or ftp command line to connect to a file on a remote server, but the file
 would need to be available to anonymous access. There will  probably also be limitations on where on the file
 can be stored on the server. The safest and easiest place to put it is in the directory where the script is
running. For instance if you run the app from url http://inetdev5/cor/imt/imtapps/dsbedit then 
w:\cor\imt\imtapps\dsbedit is the folder where the script runs from, so storing the data file in this folder
 would mean that you wouldn't need to use a path, just the file name.</p>
<p>The format for the data file is as follows:-</p>
<PRE>Group CN, Short Name (SamAccoutName), Group OU,Group Description, Member CN1, Member CN2, etc...</PRE>
<p>For example:</p>
<PRE>Widgets-Team,CN=Users,Widgets Management Team, billg,lellison,sjobs
Gurus-Team,OU=OM-Groups,OU=EDIR,The real Experts,ghopper,linus
Domain Users,CN=Users,,ghopper,linus,billg,lellison,sjobs</PRE>
<p>Note especially that OUs are in LDAP format delimited by commas, and you need to get the 
identification right, CN, OU or whatever. The default groups in AD are in CN containers! 
The OUs must be relative to the base OU</p>  
<p>If a group already exists then the associations will still be added, but the description will be ignored.
The same group may appear on multiple lines in the csv file if this is more convenient. </p>
<p>If updating existing groups or using the same group on multiple lines it is quite easy to repeat an association.
 One limitation in the script is that it doesn't attempt to distinguish between association events that fail because 
 the association already exists, which is benign, and association events which fail because of a technical problem. 
 Be aware of this when evaluating any failure reports in the script output.</p> 
 
<p>dsgrpcrt.php is &copy; Surrey County Council 2010. </p> 

HTMLFORM;
echo $a;
}

function EdirtoLdap($DN) {
	//echo "<pre>Edirtoldap function</pre>";
	// OK here we have a Netware format Context
	// ie fred.bill.adrian.org
	// we want to convert it to LDAP format eg
	// cn=fred,ou=bill,ou=adrian,o=org
	$last = strrchr($DN, ".");
	$DN = str_replace($last,",O=".substr($last,1),$DN);
	$DN = str_replace(".",",OU=",$DN);
	return "OU=" . $DN;
}

function ldap_escape($str) {

	// This all gets a bit sticky and this code is definitely not exhaustive. 
	// depending on what characters appear in your AD naming you may wish to get 
	// other values in here to escape or in general handle things differently
	// this is quite a pain to debug because its all about the LDAP search
	// syntax which I for one find a bit painful.
	// in particular this function doesn't handle striings that already contain
	// escaped characters, and this is quite a flaw that needs to be handled
	// you will probably end up constructiung putative escaped filters and putting 
	// them into LDAP browsers and alll sorts of other tests. 
	
	$metaChars = array('*', '(', ')',  chr(0));
	$quotedMetaChars = array(); 
	foreach ($metaChars as $key => $value){
		$quotedMetaChars[$key] = "\\" . $value; 
	}
	$str=str_replace($metaChars,$quotedMetaChars,$str); //replace them
	return ($str); 
} 

function closedocument(){
	echo "</div>\n</body>\n</html>\n";
}	

?>
</div>
</body>
</html>