<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"   "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>DS Batch Editing Utility</title>

<!-- 
	University of Illinois/NCSA Open Source License for dsbrun.php.

Copyright (c) 2008 Jim Champ/Surrey County Council 
All rights reserved.
Developed by: 		Jim Champ
                    www.devboats.co.uk/idmphp/
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimers. 

Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimers
in the documentation and/or other materials provided with the
distribution. 

Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
or promote products derived from this Software without specific prior
written permission. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE. 

-->

</head>
<body>

<h1>DS Batch Editing Utility</h1>

<?php 
// global array of data records...
global $arrbrecords;

if (@$_POST['ldap_id'] > "" ) {
	// newer systems support the _post system for posted variable
	// older ones http_post_vars so we test for both...
	$working_ou=$_POST['working_ou'];
	$ldap_pw=$_POST['ldap_pw'];
	$ldap_id=$_POST['ldap_id'];
	$ldap_server=$_POST['ldap_server'];
	$hd_server=$_POST['hd_server'];
	$hd_volume=$_POST['hd_volume'];
	$hd_path=$_POST['hd_path'];
	$hd_dn="";
	$csv_data_file=$_POST['csv_data_file'];	
} else {
	if (@$HTTP_POST_VARS['ldap_id'] > "" ) {
		$working_ou=$HTTP_POST_VARS['working_ou'];
		$ldap_pw=$HTTP_POST_VARS['ldap_pw'];
		$ldap_id=$HTTP_POST_VARS['ldap_id'];
		$ldap_server=$HTTP_POST_VARS['ldap_server'];
		$hd_server=$HTTP_POST_VARS['hd_server'];
		$hd_volume=$HTTP_POST_VARS['hd_volume'];
		$hd_path=$HTTP_POST_VARS['hd_path'];
		$hd_dn="";
		$csv_data_file=$HTTP_POST_VARS['csv_data_file'];	
	
	} else {
		DisplayForm();
		exit;
	}
}

// basic sequence with LDAP is connect, bind, search, interpret search
// result, close connection


// So we start by connecting to LDAP

echo "<p>Connection to LDAP server";

$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!

if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo " succeeded<br />";
	// we have now made an LDAP connection
} else { 
	echo " failed.</p><h2>LDAP Authentication Failed</h2>\n";
	echo "<p>User id and/or Password credentials were incorrect</p>\n";
	echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
	echo "correct LDAP syntax (cn=username,ou=unit,o=org) rather than NDS syntax for the user id.</p>\n";
	exit;
}

readinfile ($csv_data_file);
global $arrbrecords;
// the first line in arrbrecords is our field names
// the rest is the data
// first field always cn
// next field is $mod attribute

$mod_attribute = strtolower($arrbrecords[0][1]);
// echo "mod attr: " . $mod_attribute;
// Now we loop through all the records we want to edit...

// here we need some code to skip the first line in arrbrecords
// because its the header and there will be no such OU
$c = array_shift($arrbrecords);
// $c is discarded because we already took what we wanted from it...

//Now we want to get the cn for the volume if we are playing with volumes
if (strlen(trim($hd_server . $hd_volume . $hd_path)) >0) {
	//echo "<p>*" . strlen(trim($hd_server . $hd_volume . $hd_path)) . "*</p>" ;
	// so in here we are playiug with homedirectory changes
	// we are manipulating homedir, lets do some checks
	if ($mod_attribute !== "homedir") {
		// we have not got the right response from the homedir
		// so we want to end
	
		echo "<h2>Invalid Home Directory Settings</h2>\n";
		echo "<p>You have set home directory settings on the form, but the column header";
		echo "in the datafile is not homedir.</p>\n";
		echo "<p>If you are tring to set home directories then please amend the data file.";
		echo " If not please use back to ";
		echo "return to the form and ensure the home directory fields are blank. </p>\n";
		exit;
	}
	// OK we have some settings, we want to authenticate them

	$hd_allpath = "cn=".$hd_server ."_". $hd_volume; 
	$sr = ldap_search($ds, $working_ou, $hd_allpath);
	// we are hunting up the volume object
	// there should of course only be one...
	$entry_count = ldap_count_entries($ds, $sr);
	if($entry_count != 1) {
		// text assumes the volume object is not found, this could
		// also be trapped if there are two identical volume objects
		// in which case the lack of notification is the least of 
		// the administrators worries! 
		echo "<h2>Invalid Home Directory Settings</h2>\n";
		echo "The new home volume was entered as" . $hd_allpath;
		echo "<p>The Home volume could not be located. Please ensure that the server and  ";
		echo "volume names are correct and the volume is located under the working OU.</p>\n";
		echo "<p>Please use back to ";
		echo "return to the form and ensure the settings are correct. </p>\n";
		exit;
	} else {
		$entry_info=ldap_get_entries($ds, $sr);
		$hd_dn = $entry_info[0]["dn"];
		echo "Home volume confirmed as ". $hd_dn . "<br />\n";
	}
}
// no else - app only validates on volume objects...


// start of loop
foreach ($arrbrecords as $c) {
	//echo "<p> each rec: " . $c[0]. $c[1] . "</p>";
	$a = Find_change_rec ($ds, $working_ou, "cn=".$c[0], $mod_attribute, $c[1], $hd_path, $hd_dn) ;
}

exit;

function Find_change_rec ($ds, $working_ou, $search_cn, $mod_attribute, $mod_value, $hd_path, $hd_dn) {

	// Search for the user entry.
	// it would be more efficient to list the attributes that we are searching for here, but
	// that means setting the contents of an array on the end of the ldap_search call to reflect the 
	// field names read from the data file. This is left as an exercise for the keen student. It ought to
	// make quite a bit of difference to performance because so many ldap_searches are done as the data 
	// file is processed.
	$sr = ldap_search($ds, $working_ou, $search_cn);
	// Count the number of entries returned and check for errors.
	//echo "Search completed";
	$entry_count = ldap_count_entries($ds, $sr);
	//echo "<p>Search completed, ".$entry_count . " entries found<br />\n";
	// we must have exactly one entry returned to be happy we are editing the right
	// object in the DS< else we must quit

	if($entry_count >1) {
		// this traps duplicate/multiple objects and writes to screen
		// but doesn't change them
		echo $search_cn ;
		echo " : The following " . $entry_count;
		echo " objects were found that match that CN";
		echo " under " . $working_ou;
		echo ", and were <b>skipped</b>.<br />\n";
		$entry_info=ldap_get_entries($ds, $sr);
		// loop through each one found...
		foreach ($entry_info as $entry_data) {
			if (strlen($entry_data["dn"])>0) {
				echo "&nbsp;&nbsp;&nbsp;&nbsp;" . $entry_data["dn"] . "<br />\n";
			}
		}
		//continue;
	} else {
		// zero or 1 finds...
		if($entry_count <1) {
			// no finds... log and continue
			echo $search_cn ;
			echo " : No objects were found that match that CN";
			echo " under " . $working_ou ;
			echo ". This file entry was <b>skipped</b>.<br />\n";
			//continue;
		 } else {
		 	// valid at last...
			// we get the entries for this one result (!)
			$entry_info=ldap_get_entries($ds, $sr);
			echo $entry_info[0]["dn"] ;
			if ($mod_attribute == "homedir") {
				// we have to assemble complex string and values
				// as we are playing with homedir
				// LDAP format for home dir 
				// taggedNameAndString = distinguishedname "#" uint32string "#" dstring
				// in practice this is DN. "#0#" . "path"
 				$mod_string["ndshomedirectory"]=$hd_dn."#0#".$hd_path."\\".$mod_value;
 				// we also get the current value...
				$ovalue = $entry_info[0]["ndshomedirectory"];
			} else {
				// mod string is just attribute and value
				$mod_string[$mod_attribute]=$mod_value;
				// get currnet again...	
				$ovalue = $entry_info[0][$mod_attribute][0];
			}
			
			if (strlen($ovalue) < 1) {
				// zero byte or no old value, so put in [no value] for readbility 
				$ovalue = "[no value]";
			}
				 
			if (@ldap_modify($ds,$entry_info[0][dn],$mod_string)) {
				// here the modify has succeeded... Log results to screen
				echo " : CN found, edit from ";
				echo $ovalue;
				echo " to ";
				echo $mod_value;
				echo "<b> succeeded</b></a>";

			} else {
				// LDAP mod failed for whatever reason...
				echo " : CN found, but the edit <b>failed</b>.";
			}				
			echo  "<br /> \n";
		}
	}
	return;
}

function ReadinFile( $fname ) {
	global $arrbrecords;
	// some local storage...
	$arrholder = array();
	$arrptr = 0;

	//First we open the csv file
	$handle = @fopen($fname, "r");
	if ($handle== false) {
		// trap for no data file...
		echo "</p><h2>Data File Open Failed</h2>\n";
		echo "<p>There are a number of reasons why this might have happened. The file might genuinely not exists, or perhaps its stored \n";
		echo "on an area of the server where the script does not have rights to open files.</p>\n";
		echo "<p>Use back to go back to the form and correct the path or move the file to somewhere the script ";
		echo "can definitely access it. The directory where the script is stored should always work.</p>\n";
		exit;
	} 	
	// file opened, continue...
	while (!feof($handle)) {
		$arr_buffer = fgetcsv($handle, 4096);
		// we always test and that way handle blank records in the file...
		// also we need to allow for there not being enough or too many fields...
		$numrecs = count($arr_buffer);
		// we just grab the first two records, any more get discarded
		if ($numrecs > 1) {
			// then we have a potentially good line with two plus records and continue processing it in here
			// so we look at each record and see if its OK...
			if (strlen(trim($arr_buffer[0])) < 2) { 
				continue;
			}
			if (strlen(trim($arr_buffer[1])) < 2) { 
				continue;
			}
			// OK we ve done crude validation and reckon we've got some records
			// now we put data in the array

			$arrbrecords[$arrptr][0] = trim($arr_buffer[0]);
			// echo "<p>" . $arrbrecords[$arrptr][0];			
						$arrbrecords[$arrptr][1] = trim($arr_buffer[1]);
			//echo "<p>" . $arrbrecords[$arrptr][1] . " " . $arrptr . "</p>";			
			$arrptr=$arrptr+1;

		} else {
			// we got here because we didn't have 2 records in the line of CSV
			// so we do nothing and continue - just discard the invalid line
			// empty lines are likely enough!
		}
	}

	if (fclose($handle)) {
		//echo "File Closed successfully<br />\n";
	} else {
		echo "\nFile Close Failed: contact Application Support.<br />\n";
	}
	return;
}

function DisplayForm(){
// this produces the form to fill in when there's not a ldap _id in the post vars. 
$form_body = <<<HTMLFORM
<form method="POST" action="dsbedit.php" enctype="x-www-form-urlencoded">
<table class="main" cellpadding="2" cellspacing="2">
	<tr>
		<td class="maintdpos">LDAP Admin User ID:</td>
		<td class="maintdpos"><input type="text" name="ldap_id" size="30"
			maxlength="80"></td>
	</tr>
	<tr>
		<td class="maintdpos">LDAP Password:</td>
		<td class="maintdpos"><input type="password" name="ldap_pw"
			size="30" maxlength="40"></td>
	</tr>
	<tr>
		<td class="maintdpos">LDAP Server:</td>
		<td class="maintdpos"><input type="text" name="ldap_server"
			value="sccnthfa5.surreycc.gov.uk" size="30" maxlength="40"></td>
	</tr>
	<tr>
		<td colspan="2">
		<hr>
		</td>
	</tr>
	<tr>
		<td class="maintdpos">Working OU/Context:</td>
		<td class="maintdpos"><input type="text" name="working_ou"
			size="30" maxlength="40"></td>
	</tr>
	<tr>
		<td class="maintdpos">CSV Data File:</td>
		<td class="maintdpos"><input type="text" name="csv_data_file"
			size="30" maxlength="40"></td>
	</tr>

	<tr>
		<td colspan="2">
		<hr>
		</td>
	</tr>
	<tr>
		<td class="maintdpos">Home Directory Server:</td>
		<td class="maintdpos"><input type="text" name="hd_server"
			size="30" maxlength="40"></td>
	</tr>
	<tr>
		<td class="maintdpos">Home Directory Volume:</td>
		<td class="maintdpos"><input type="text" name="hd_volume"
			size="30" maxlength="40"></td>
	</tr>

	<tr>
		<td class="maintdpos">Home Directory Host Path:</td>
		<td class="maintdpos"><input type="text" name="hd_path" size="30"
			maxlength="40"></td>
	</tr>

	<tr>
		<td colspan="2">
		<hr>
		</td>
	</tr>

	<tr>
		<td class="maintdpos"><input type="submit" value="Post Details"></td>
		<td class="maintdpos"><input type="reset" value="Clear Form"></td>
	</tr>
</table>
</form>
<h3>Notes and Help</h3>
<p>LDAP Admin user id must be in typeful LDAP format ie <code>cn=adminuser,o=organisation</code>.
The delimiters must be commas and not full stops.</p>
<p>LDAP server. It would be best to pick a server that holds
replicas containing the objects that you wish to edit.</p>
<p>Working OU/Context must also be in typeful LDAP format, so <code>ou=dept,ou=building,ou=town,o=organisation</code>.
If you are changing home directories then the servers home volume must
be under the Working OU as well as all the users contexts.</p>
<p>CSV data file can be a path local to the server where you are
running the script, and this is the simplest option. It may be possible
to use an HTTP or FTP command line to connect to a file on a remote
server, but the file would need to be available to anonymous access.
There will probably also be limitations on where on the file can be
stored on the server. The simplest and easiest place to put it is in the
directory where the script is run from. this means that you wouldn't
need to use a path, just the file name.</p>
<p>Where Home directory and volume are specified these will be set
for every user in the file. In this case the parameter in the file must
be the directory name (usually the same as the user name) and the column
header homedir.</p>
<p>Examples of data files to change first name and home directory
are as follows:-</p>
<pre>
cn,givenname
billg,William
lellison,Larry
sjobs,Steve
ghopper,Grace
linus,Linus

cn,homedir
billg,billg
lellison,lellison
sjobs,sjobs
ghopper,ghopper
linus,linus
</pre>
<p>You may use dsbedit to change most NDS paramaters that are
editable my LDAP. The main restriction is if data is encoded. For
instance you can enable and disable login, which is a boolean value, by
using true and false.</p>
<pre>
CN,loginDisabled
billg,false
ghopper,true
</pre>
<p>Make sure you use the LDAP name of the attribute, which may well
be different from the NDS value. Its a good idea to use a LDAP browser
like the softterra one to make sure that your proposed changes have the
right values and will work.</p>
HTMLFORM;
echo $form_body;
}
?>
</body>
</html>
